/*
    Copyright (C) 2007    Dmitry Ivanov, vonami@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PARTIMAGENG_EXT2PARTITION
#define PARTIMAGENG_EXT2PARTITION

#include <ext2fs/ext2fs.h>
#include <sys/types.h>

#include "partition.h"

namespace PartimageNG {
        class Ext2Partition;
}

class PartimageNG::Ext2Partition : public PartimageNG::Partition {

friend class PartitionManager;

protected:

        Ext2Partition(PedPartition *pedPartition);

public:

        virtual ~Ext2Partition();

        virtual size_t blockSize() const;
        virtual u_int64_t blocksCount() const;
        virtual u_int64_t usedBlocks() const;
        virtual const struct Bitmap* bitmap();

        virtual bool dumpInternalBitmap(int dumpd) const;

private:

        ext2_filsys m_ext2part;
        struct Bitmap m_bitmap;
        u_int64_t m_usedBlocks;
};

#endif /* PARTIMAGENG_EXT2PARTITION */
