/*
    Copyright (C) 2007    Dmitry Ivanov, vonami@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PARTIMAGENG_FAT32PARTITION
#define PARTIMAGENG_FAT32PARTITION

#include "partition.h"

namespace PartimageNG {
        class Fat32Partition;
}

class PartimageNG::Fat32Partition : public PartimageNG::Partition {

friend class PartitionManager;

protected:

        Fat32Partition(PedPartition *pedPartition);

public:

        virtual ~Fat32Partition();

        virtual size_t blockSize() const;
        virtual u_int64_t blocksCount() const;
        virtual u_int64_t usedBlocks() const;
        virtual const struct Bitmap* bitmap();

        virtual bool dumpInternalBitmap(int dumpd) const;

private:

        bool fatClusterFree(u_int32_t *fat, u_int32_t ncluster) const;

private:

        u_int32_t *m_fat;
        u_int64_t m_fatSize;
        struct Bitmap m_bitmap;
        u_int64_t m_blocksCount;
        u_int64_t m_usedBlocks;
};

#endif /* PARTIMAGENG_FAT32PARTITION */
