/*
    Copyright (C) 2007    Dmitry Ivanov, vonami@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PARTIMAGENG_NTFSPARTITION
#define PARTIMAGENG_NTFSPARTITION

#include <sys/types.h>

#include "partition.h"

namespace PartimageNG {
        class NtfsPartition;
}

class PartimageNG::NtfsPartition : public PartimageNG::Partition {

friend class PartitionManager;

protected:

        NtfsPartition(const PedPartition *pedPartition);

public:

        virtual ~NtfsPartition();

        virtual size_t blockSize() const;
        virtual u_int64_t blocksCount() const;
        virtual u_int64_t usedBlocks() const;
        virtual const struct Bitmap* bitmap();

        virtual bool dumpInternalBitmap(int dumpd) const;

private:

        // should be ntfs_volume* but libntfs is not c++ friendly
        // so i cannot #include <ntfs/volume.h>
        void *m_ntfs_vol;

        struct Bitmap m_bitmap;
        u_int64_t m_blockSize;
        u_int64_t m_blocksCount;
        u_int64_t m_usedBlocks;
};

#endif /* PARTIMAGENG_NTFSPARTITION */
