/*
    Copyright (C) 2007    Dmitry Ivanov, vonami@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PARTIMAGENG_NTFSPARTITION_C
#define PARTIMAGENG_NTFSPARTITION_C

struct ntfs_badblocks_run {
        u_int64_t start;
        u_int64_t length;
};

void* partimage_ng_ntfs_open(const char *device);
int partimage_ng_ntfs_close(void *ntfs_vol);
u_int8_t* partimage_ng_ntfs_bitmap(void *ntfs_vol);
size_t partimage_ng_ntfs_block_size(void *ntfs_vol);
u_int64_t partimage_ng_ntfs_blocks_count(void *ntfs_vol);
u_int64_t partimage_ng_ntfs_bitmap_data_size(void *ntfs_vol);
u_int64_t partimage_ng_ntfs_bitmap_allocated_size(void *ntfs_vol);
struct ntfs_badblocks_run* partimage_ng_ntfs_badclusters(void *ntfs_vol);

#endif /* PARTIMAGENG_NTFSPARTITION_C */
