/*
    Copyright (C) 2007    Dmitry Ivanov, vonami@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>

#include "partition.h"

using namespace PartimageNG;
using namespace std;

Partition::Partition(const PedPartition *pedPartition)
        :m_pedPartition(pedPartition)
{
        cerr << " == Processing partition: type " << pedPartition->type << ", geometry {"
             << pedPartition->geom.start << ", " << pedPartition->geom.end << "} == " << endl;
        if ( pedPartition->type != PED_PARTITION_EXTENDED ) {
                if ( pedPartition->fs_type != 0 )
                        cerr << "Filesystem: " << pedPartition->fs_type->name << endl;
                else
                        cerr << "Unknown filesystem" << endl;
        }
}

Partition::~Partition()
{
}

const char* Partition::path() const
{
        return ped_partition_get_path(m_pedPartition);
}

u_int16_t Partition::type() const
{
        return m_pedPartition->type;
}

u_int64_t Partition::startSector() const
{
        return m_pedPartition->geom.start;
}

u_int64_t Partition::endSector() const
{
        return m_pedPartition->geom.end;
}

const char* Partition::filesystem() const
{
        if ( m_pedPartition->type == PED_PARTITION_EXTENDED )
                return 0;

        if ( m_pedPartition->fs_type == 0 )
                return 0;

        return m_pedPartition->fs_type->name;
}
